it-swarm.com.de

Zahlen in Bash vergleichen

Ich fange an zu lernen, wie man Skripte für das Bash-Terminal schreibt, aber ich kann nicht herausfinden, wie die Vergleiche richtig funktionieren. Das Skript, das ich benutze, ist:

echo "enter two numbers";
read a b;

echo "a=$a";
echo "b=$b";

if [ $a \> $b ];
then 
    echo "a is greater than b";
else
    echo "b is greater than a";
fi;

Das Problem besteht darin, dass die Zahl ab der ersten Ziffer verglichen wird, d. H. 9 ist größer als 10, aber 1 ist größer als 09.

Wie kann ich die Zahlen in einen Typ konvertieren, um einen echten Vergleich durchzuführen?

430
advert2013

In der Bash sollten Sie Ihren Check-In durchführen arithmetischer Kontext :

if (( a > b )); then
    ...
fi

Für POSIX-Shells, die (()) nicht unterstützen, können Sie -lt und -gt verwenden.

if [ "$a" -gt "$b" ]; then
    ...
fi

Sie können eine vollständige Liste der Vergleichsoperatoren mit help test abrufen.

734
jordanm

Schlicht und einfach

#!/bin/bash

a=2462620
b=2462620

if [ "$a" -eq "$b" ];then
  echo "They're equal";
fi

Sie können sich dieses Cheatsheet ansehen, wenn Sie mehr Zahlenvergleiche in der wundervollen Welt des Bash Scripting wünschen.

Kurz gesagt, ganze Zahlen können nur verglichen werden mit:

-eq # equal
-ne # not equal
-lt # less than
-le # less than or equal
-gt # greater than
-ge # greater than or equal
136

Es gibt auch eine nette Sache, die manche Leute vielleicht nicht kennen:

echo $(( a < b ? a : b ))

Dieser Code gibt die kleinste Zahl aus a und b aus.

In Bash bevorzuge ich dies, da es sich eher um eine bedingte Operation handelt als um die Verwendung von (( )), die eher arithmetisch ist.

[[ N -gt M ]]

Es sei denn, ich mache komplexe Sachen wie

(( (N + 1) > M ))

Aber jeder hat nur seine eigenen Vorlieben. Traurige Sache ist, dass einige Leute ihre inoffiziellen Standards auferlegen.

pdate:

Das können Sie eigentlich auch:

[[ 'N + 1' -gt M ]]

Damit können Sie neben arithmetischen Dingen noch etwas hinzufügen, das Sie mit [[ ]] tun könnten.

17
konsolebox

Dieser Code kann auch Floats vergleichen. Es wird awk verwendet (es ist keine reine Bash), dies sollte jedoch kein Problem sein, da awk ein POSIX-Standardbefehl ist, der höchstwahrscheinlich standardmäßig mit Ihrem Betriebssystem geliefert wird.

$ awk 'BEGIN {return_code=(-1.2345 == -1.2345) ? 0 : 1; exit} END {exit return_code}'
$ echo $?
0
$ awk 'BEGIN {return_code=(-1.2345 >= -1.2345) ? 0 : 1; exit} END {exit return_code}'
$ echo $?
0
$ awk 'BEGIN {return_code=(-1.2345 < -1.2345) ? 0 : 1; exit} END {exit return_code}'
$ echo $?
1
$ awk 'BEGIN {return_code=(-1.2345 < 2) ? 0 : 1; exit} END {exit return_code}'
$ echo $?
0
$ awk 'BEGIN {return_code=(-1.2345 > 2) ? 0 : 1; exit} END {exit return_code}'
$ echo $?

Verwenden Sie diese Funktion, um die Verwendung zu verkürzen:

compare_nums()
{
   # Function to compare two numbers (float or integers) by using awk.
   # The function will not print anything, but it will return 0 (if the comparison is true) or 1
   # (if the comparison is false) exit codes, so it can be used directly in Shell one liners.
   #############
   ### Usage ###
   ### Note that you have to enclose the comparison operator in quotes.
   #############
   # compare_nums 1 ">" 2 # returns false
   # compare_nums 1.23 "<=" 2 # returns true
   # compare_nums -1.238 "<=" -2 # returns false
   #############################################
   num1=$1
   op=$2
   num2=$3
   E_BADARGS=65

   # Make sure that the provided numbers are actually numbers.
   if ! [[ $num1 =~ ^-?[0-9]+([.][0-9]+)?$ ]]; then >&2 echo "$num1 is not a number"; return $E_BADARGS; fi
   if ! [[ $num2 =~ ^-?[0-9]+([.][0-9]+)?$ ]]; then >&2 echo "$num2 is not a number"; return $E_BADARGS; fi

   # If you want to print the exit code as well (instead of only returning it), uncomment
   # the awk line below and comment the uncommented one which is two lines below.
   #awk 'BEGIN {print return_code=('$num1' '$op' '$num2') ? 0 : 1; exit} END {exit return_code}'
   awk 'BEGIN {return_code=('$num1' '$op' '$num2') ? 0 : 1; exit} END {exit return_code}'
   return_code=$?
   return $return_code
}

$ compare_nums -1.2345 ">=" -1.2345 && echo true || echo false
true
$ compare_nums -1.2345 ">=" 23 && echo true || echo false
false
5

Ich habe dies gelöst, indem ich eine kleine Funktion verwendet habe, um Versionszeichenfolgen in einfache ganzzahlige Werte zu konvertieren, die verglichen werden können:

function versionToInt() {
  local IFS=.
  parts=($1)
  let val=1000000*parts[0]+1000*parts[1]+parts[2]
  echo $val
}

Dies macht zwei wichtige Annahmen:

  1. Eingabe ist ein " normaler SemVer-String "
  2. Jeder Teil ist zwischen 0-999

Zum Beispiel

versionToInt 12.34.56  # --> 12034056
versionToInt 1.2.3     # -->  1002003

Beispiel für das Testen, ob der Befehl npm die Mindestanforderung erfüllt ...

NPM_ACTUAL=$(versionToInt $(npm --version))  # Capture npm version
NPM_REQUIRED=$(versionToInt 4.3.0)           # Desired version
if [ $NPM_ACTUAL \< $NPM_REQUIRED ]; then
  echo "Please update to [email protected]"
  exit 1
fi
2
broofa

Wenn Sie Floats haben, können Sie eine Funktion schreiben und diese dann verwenden, z.

#!/bin/bash

function float_gt() {
    Perl -e "{if($1>$2){print 1} else {print 0}}"
}

x=3.14
y=5.20
if [ $(float_gt $x $y) == 1 ] ; then
    echo "do stuff with x"
else
    echo "do stuff with y"
fi
0
Sue